import { TemplateResult, CSSResult } from 'lit-element';
import ArenaPlugin from '../interfaces/ArenaPlugin';
import { AnyArenaNode } from '../interfaces/ArenaNode';
import WebComponent from '../helpers/WebComponent';
import ArenaAttributes from '../interfaces/ArenaAttributes';
import { ArenaFormatings } from '../interfaces/ArenaFormating';
import { Srcset, ImagePluginOptions } from './imagePlugin';
export declare const getPublic: (srcset: Srcset | undefined) => (node: AnyArenaNode, frms: ArenaFormatings) => string;
export declare class ArenaFigure extends WebComponent {
    src: string | undefined;
    width: number | undefined;
    height: number | undefined;
    withCaption: boolean;
    loading: boolean;
    get input(): HTMLInputElement | undefined;
    static get styles(): CSSResult[];
    render(): TemplateResult;
    handleChange({ detail }: {
        detail: ArenaAttributes;
    }): void;
}
declare const imageWithCaptionPlugin: (opts?: Partial<ImagePluginOptions> | undefined) => ArenaPlugin;
export default imageWithCaptionPlugin;
//# sourceMappingURL=imageWithCaptionPlugin.d.ts.map