export default class EventManager {
    constructor(asm) {
        this.asm = asm;
        this.handlers = {};
    }
    fire(event) {
        this.asm.logger.log(`fire:  ${event}`);
        const eventName = typeof event === 'string' ? event : event.name;
        if (this.handlers[eventName]) {
            this.handlers[eventName].map((handler) => handler(event));
        }
    }
    subscribe(event, handler) {
        if (!this.handlers[event]) {
            this.handlers[event] = [];
        }
        this.handlers[event].push(handler);
    }
}
//# sourceMappingURL=EventManager.js.map